wd = 600;
ht = 500;

noise1 = random('Normal',127,10,ht,wd);
noise2 = random('Normal',127,40,ht,wd);

[j,i] = meshgrid(1:wd,1:ht);
mask = sqrt((i-ht/2).^2+(j-wd/2).^2)<( (wd+ht)/8 );
mask_bar = 1-mask;

bmap = [0 0 0; 1 1 1];
map = [ 0:255; 0:255; 0:255]'/255; 

figure
image(mask+1)
axis('image')
colormap(bmap)



img1 = mask.*noise1 + mask_bar.*noise2;

img2 = mask_bar.*noise1 + mask.*noise2;

figure
image(img1)
colormap(map)
axis('image')

figure
image(img2)
colormap(map)
axis('image')

img1 = img1/255;
img1 = max( min(img1,1),0);
imwrite(img1,'input/image.1.pgm');

img2 = img2/255;
img2 = max( min(img2,1),0);
imwrite(img2,'input/image.2.pgm');

data_1 = [noise1(1:ht,1),noise2(1:ht,1)];
save input/data.1 data_1 -ascii
data_2 = [noise2(1:ht,2),noise1(1:ht,2)];
save input/data.2 data_2 -ascii




