/*
* All questions regarding the software should be addressed to
*
*       Prof. Charles A. Bouman
*       Purdue University
*       School of Electrical and Computer Engineering
*       1285 Electrical Engineering Building
*       West Lafayette, IN 47907-1285
*       USA
*       +1 765 494 0340
*       +1 765 494 3358 (fax)
*       email:  bouman@ecn.purdue.edu
*       http://www.ece.purdue.edu/~bouman
*
* Copyright (c) 1995 The Board of Trustees of Purdue University.
*
* Permission to use, copy, modify, and distribute this software and its
* documentation for any purpose, without fee, and without written agreement is
* hereby granted, provided that the above copyright notice and the following
* two paragraphs appear in all copies of this software.
*
* IN NO EVENT SHALL PURDUE UNIVERSITY BE LIABLE TO ANY PARTY FOR DIRECT,
* INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES ARISING OUT OF THE
* USE OF THIS SOFTWARE AND ITS DOCUMENTATION, EVEN IF PURDUE UNIVERSITY HAS
* BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*
* PURDUE UNIVERSITY SPECIFICALLY DISCLAIMS ANY WARRANTIES, INCLUDING, BUT NOT
* LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A
* PARTICULAR PURPOSE.  THE SOFTWARE PROVIDED HEREUNDER IS ON AN "AS IS" BASIS,
* AND PURDUE UNIVERSITY HAS NO OBLIGATION TO PROVIDE MAINTENANCE, SUPPORT,
* UPDATES, ENHANCEMENTS, OR MODIFICATIONS.
*/
#include "smap_region.h"


int levels_reg(struct Region *region)
{
  int D;
  int wd,ht;
  struct Region region_buff;

  /* save region stucture */
  copy_reg(region,&region_buff);

  D=0;
  reg_to_wdht(region,&wd,&ht);
  while((wd>2)&&(ht>2)) {
    D++;
    dec_reg(region);
    reg_to_wdht(region,&wd,&ht);
    }

  /* restore region structure */
  copy_reg(&region_buff,region);

  return(D);
}

void dec_reg(struct Region *region)
{
   region->xmin = region->xmin/2;
   region->xmax = region->xmax/2;
   region->ymin = region->ymin/2;
   region->ymax = region->ymax/2;
}

void copy_reg(
  struct Region *region1,
  struct Region *region2
)
{
   region2->xmin = region1->xmin;
   region2->xmax = region1->xmax;
   region2->ymin = region1->ymin;
   region2->ymax = region1->ymax;

   region2->free.left = region1->free.left;
   region2->free.right = region1->free.right;
   region2->free.top = region1->free.top;
   region2->free.bottom = region1->free.bottom;
}

void reg_to_wdht(
  struct Region *region,
  int *wd,
  int *ht
)
{
   *wd = region->xmax - region->xmin;
   *ht = region->ymax - region->ymin;
}

